@ECHO OFF
REM Start Execution
CALL :initialize_parameters

REM !!!!!!DO NOT CHANGE ABOVE THIS LINE!!!!!!


REM Define models to execute
REM Model 1 - Government Deficit - 1 LB
SET  Model_definition=Model=TAX_HGEMED _Options_StartYear=2005 _Options_EndYear=2005 _Options_Peninsular=1 _Options_PeninandExtra=0 _UseLoadBlockAggregation=1 _loadblockaggregation=LB_1 Calibration_Problem=MinMaxPlus TD_Solver=MCP BU_Solver=NLP _Options_exec_fc=1 _Options_exec_co2=1 _Options_exec_vom=1 _Options_exec_equip=1 _Options_exec_labor=1 _Options_exec_sc=1 _Options_exec_capac=1 _Options_exec_emissrigths=1 _Options_exec_prem=0 _Options_exec_DR_displac=0 _Options_exec_DR_reduc=0 _Simulation_SOx_Tax=1000 _Simulation_NOx_Tax=1000 _Simulation_CO2e_Diffuse_Tax=0 _Simulation_tax_reform_deficit_reduction=1 _Simulation_tax_reform_social_contributions=0 _Simulation_tax_reform_Lump_sum=0 _Simulation_Renewable_Premium_Tax=0 _Simulation_Fuel_Tax=0
CALL :Model_execution 
REM Model 2 - Socialo contribution subsidies - 1 LB
SET  Model_definition=_Simulation_tax_reform_deficit_reduction=0 _Simulation_tax_reform_social_contributions=1 _Simulation_tax_reform_Lump_sum=0
CALL :Model_execution 
REM Model 3 - Production subsidies - 1 LB
SET  Model_definition=_Simulation_tax_reform_deficit_reduction=0 _Simulation_tax_reform_social_contributions=0 _Simulation_tax_reform_Lump_sum=1
CALL :Model_execution 


REM !!!!!!DO NOT CHANGE BELLOW THIS LINE!!!!!!

REM End Execution
GOTO END


:initialize_parameters
SET count=0
SET BATNAME=%~n0
SET FULL_EXECUTION_START_TIME=%TIME% 
ECHO. >"%BATNAME%.log"
GOTO :eof

:Model_execution
SET /a count+=1
ECHO. >>"%BATNAME%.log"
ECHO ----------------------------  MODEL %count% EXECUTION  -------------------------- >>"%BATNAME%.log"
set START_TIME=%TIME%
start /wait gemed.exe %Model_definition%
set END_TIME=%TIME%
ECHO. >>"%BATNAME%.log"
CALL :calculate_duration
ECHO. >>"%BATNAME%.log"
type .\Model\Execution.log >>"%BATNAME%.log"
GOTO :eof

:calculate_duration
set STARTTIME=%START_TIME%
set ENDTIME=%END_TIME%
rem convert STARTTIME and ENDTIME to centiseconds
set /A STARTTIME=(1%STARTTIME:~0,2%-100)*360000 + (1%STARTTIME:~3,2%-100)*6000 + (1%STARTTIME:~6,2%-100)*100 + (1%STARTTIME:~9,2%-100)
set /A ENDTIME=(1%ENDTIME:~0,2%-100)*360000 + (1%ENDTIME:~3,2%-100)*6000 + (1%ENDTIME:~6,2%-100)*100 + (1%ENDTIME:~9,2%-100)
rem calculating the duration
set /A DURATION=%ENDTIME%-%STARTTIME%
rem we might have measured the time inbetween days
rem if %ENDTIME% LSS %STARTTIME% set set /A DURATION=%STARTTIME%-%ENDTIME%
rem now break the centiseconds down to hors, minutes, seconds and the remaining centiseconds
set /A DURATIONH=%DURATION% / 360000
set /A DURATIONM=(%DURATION% - %DURATIONH%*360000) / 6000
set /A DURATIONS=(%DURATION% - %DURATIONH%*360000 - %DURATIONM%*6000) / 100
set /A DURATIONHS=(%DURATION% - %DURATIONH%*360000 - %DURATIONM%*6000 - %DURATIONS%*100)
rem some formatting
if %DURATIONH% LSS 10 set DURATIONH=0%DURATIONH%
if %DURATIONM% LSS 10 set DURATIONM=0%DURATIONM%
if %DURATIONS% LSS 10 set DURATIONS=0%DURATIONS%
if %DURATIONHS% LSS 10 set DURATIONHS=0%DURATIONHS%
echo     Duration: %DURATIONH%:%DURATIONM%:%DURATIONS%,%DURATIONHS% Start time: %START_TIME% End time: %END_TIME% >>"%BATNAME%.log"
GOTO :eof

:END
REM displaying total execution time
set FULL_EXECUTION_END_TIME=%TIME% 
set START_TIME=%FULL_EXECUTION_START_TIME%
set END_TIME=%FULL_EXECUTION_END_TIME%
ECHO. >>"%BATNAME%.log"
ECHO. >>"%BATNAME%.log"
ECHO ------------------------ ALL MODELS EXECUTION TIME ------------------------- >>"%BATNAME%.log"
ECHO. >>"%BATNAME%.log"
CALL :calculate_duration
start notepad.exe "%BATNAME%.log"
END



